### R code from vignette source 'CoGAPSUsersManual.Rnw'

###################################################
### code chunk number 1: GAPSModSim
###################################################
library('CoGAPS')
data('ModSim')
nIter <- 500000
results <- GAPS(data=ModSim.D, unc=0.01, isPercentError=FALSE,
                numPatterns=3, SAIter=2*nIter, iter = nIter,
                outputDir='ModSimResults')
plotGAPS(results$Amean, results$Pmean, 'ModSimFigs')
message('Deleting analysis results from GAPS for Vignette')
unlink('ModSimResults', recursive=T)


###################################################
### code chunk number 2: ModSimPtrue
###################################################
arrayIdx <- 1:ncol(ModSim.P.true)
matplot(arrayIdx, t(ModSim.P.true), type='l', lwd=10)


###################################################
### code chunk number 3: SimCoGAPS
###################################################
library('CoGAPS')
data('EasySimGS')
nIter <- 5e+05 
results <- CoGAPS(data=DGS, unc=0.01, isPercentError=FALSE,
                  GStoGenes=gs,
                  numPatterns=3,
                  SAIter = 2*nIter, iter = nIter,
                  outputDir='GSResults', plot=FALSE)
plotGAPS(results$Amean, results$Pmean, 'GSFigs')
message('Deleting analysis results from CoGAPS for Vignette')
unlink('GSResults', recursive=T)


###################################################
### code chunk number 4: CoGAPSUsersManual.Rnw:360-372 (eval = FALSE)
###################################################
## library('CoGAPS')
## data('GIST_TS_20084')
## data('TFGSList')
## nIter <- 50000000 
## results <- CoGAPS(data=GIST.D, unc=GIST.S,
##                   GStoGenes=tf2ugFC,
##                   numPatterns=5,
##                   SAIter = 2*nIter, iter = nIter,
##                   outputDir='GISTResults', plot=FALSE)
## plotGAPS(results$Amean, results$Pmean, 'GISTFigs')
## message('Deleting analysis results from CoGAPS for Vignette')
## unlink('GISTResults', recursive=T)


###################################################
### code chunk number 5: CoGAPSUsersManual.Rnw:410-420 (eval = FALSE)
###################################################
## data(TFSimData)
## results <- GAPS(data=TFGeneReg$D,
##                 		  unc=0.1*pmax(TFGeneReg$M,1),
##                 		  isPercentError=FALSE,
##                 		  numPatterns=4,
##                 		  SAIter = 2*nIter, iter = nIter,
##                 		  outputDir='GSResults')
## TFtargets <- lapply(TFGeneReg$TFGeneReg,names)
## TFGenesP <- lapply(TFtargets, function(x){
##    computeGeneGSProb(Amean=results$Amean, Asd=results$Asd, GSGenes=x)})


###################################################
### code chunk number 6: CoGAPSUsersManual.Rnw:427-450 (eval = FALSE)
###################################################
## # load the data
## data('GIST_TS_20084')
## data('TFGSList')
## 
## # define transcription factors of interest based on Ochs et al. (2009)
## TFs <- c("c.Jun", 'NF.kappaB', 'Smad4', "STAT3", "Elk.1", "c.Myc", "E2F.1",
##          "AP.1", "CREB", "FOXO", "p53", "Sp1")
## 
## # run the GAPS matrix factorization
## nIter <- 5e7
## 
## GISTResults <- GAPS(data=GIST.D, unc=GIST.S,
##                     numPatterns=5, outputDir = 'GISTGSCoGAPS',
##                     isPercentError=F, SAIter=2*nIter, iter=nIter)
## 
## # set membership statistics
## permTFStats <- list()
## for (tf in TFs) {
##      genes <- levels(tf2ugFC[,tf])
##      genes <- genes[2:length(genes)]
##      permTFStats[[tf]] <- computeGeneTFProb(Amean = GISTResults$Amean,
##                                             Asd = GistResults$Asd, genes)
## }


